module GraphQLHelper where

import qualified Control.Exception as E
import qualified Components.Parsers.QueryParser as QP
import qualified Components.ObjectHandlers.ServerObjectValidator as SOV
import qualified Components.QueryComposers.SQLQueryComposer as QC
import qualified Components.ObjectHandlers.ServerObjectTrimmer as SOT
import Model.ServerObjectTypes
import Model.ServerExceptions


checkString :: String -> [(String,[String])] -> [RootObject]
checkString str svrobjs = if (QP.validateQuery str)==True then (QP.parseStringToObjects str svrobjs) else E.throw SyntaxException
checkObjectsToSql :: [(String,[String])] -> [(String,[String])] -> [(String,[String])] -> [(String,String,[String])] -> [RootObject] -> ([RootObject],[[String]])
checkObjectsToSql sss sos sodn sor ros = if (SOV.checkObjectsAttributes ros sss sos)==True then (reducedObjects,QC.makeSqlQueries reducedObjects sodn sor) else (E.throw InvalidObjectSubFieldException)
                                    where reducedObjects = SOT.mergeDuplicatedRootObjects ros
